/*
	SHARP MZ-700 Emulator 'EmuZ-700'
	Skelton for retropc emulator

	Author : Takeda.Toshiya
	Date   : 2008.06.05 -

	[ keyboard ]
*/

#ifndef _KEYBOARD_H_
#define _KEYBOARD_H_

#include "../vm.h"
#include "../../emu.h"
#include "../device.h"

#define SIG_KEYBOARD_COLUMN	0

static const int key_map[10][8] = {
	{0x0d, 0xba, 0xbb, 0x00, 0x09, 0x78, 0x21, 0x22},
	{0x00, 0x00, 0x00, 0xdd, 0xdb, 0xc0, 0x5a, 0x59},
	{0x58, 0x57, 0x56, 0x55, 0x54, 0x53, 0x52, 0x51},
	{0x50, 0x4f, 0x4e, 0x4d, 0x4c, 0x4b, 0x4a, 0x49},
	{0x48, 0x47, 0x46, 0x45, 0x44, 0x43, 0x42, 0x41},
	{0x38, 0x37, 0x36, 0x35, 0x34, 0x33, 0x32, 0x31},
	{0xbe, 0xbc, 0x39, 0x30, 0x20, 0xbd, 0xde, 0xdc},
	{0xbf, 0xe2, 0x25, 0x27, 0x28, 0x26, 0x2e, 0x2d},
	{0x10, 0x00, 0x00, 0x00, 0x00, 0x00, 0x11, 0x08},
	{0x00, 0x00, 0x00, 0x74, 0x73, 0x72, 0x71, 0x70}
};

class KEYBOARD : public DEVICE
{
private:
	DEVICE *d_pio;
	int did_pio;
	
	uint8* key_stat;
	uint8 column;
	void update_key();
	
public:
	KEYBOARD(VM* parent_vm, EMU* parent_emu) : DEVICE(parent_vm, parent_emu) {}
	~KEYBOARD() {}
	
	// common functions
	void initialize();
	void write_signal(int id, uint32 data, uint32 mask);
	void event_frame();
	
	// unique function
	void set_context_pio(DEVICE* device, int id) {
		d_pio = device; did_pio = id;
	}
};

#endif
